<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>human_control: Q_move Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">human_control
   </div>
   <div id="projectbrief">ROS Package used in coordination with the ospi2urdf package.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Data Fields</a>  </div>
  <div class="headertitle">
<div class="title">Q_move Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Simple class testing the publication of Q vector to Rviz through JointState.  
 <a href="classQ__move.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a635c60dab35a1cc6bafdfe318734f011"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classQ__move.html#a635c60dab35a1cc6bafdfe318734f011">Q_move</a> (const std::string urdf_filename, double cons_speed, double name)</td></tr>
<tr class="memdesc:a635c60dab35a1cc6bafdfe318734f011"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a new q move::q move object.  <a href="#a635c60dab35a1cc6bafdfe318734f011">More...</a><br /></td></tr>
<tr class="separator:a635c60dab35a1cc6bafdfe318734f011"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae24b2f1a2a766258e2797793cc23c085"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classQ__move.html#ae24b2f1a2a766258e2797793cc23c085">move_all_articulations</a> (double &amp;jl, int &amp;i_joint)</td></tr>
<tr class="memdesc:ae24b2f1a2a766258e2797793cc23c085"><td class="mdescLeft">&#160;</td><td class="mdescRight">Move a specific articulation i_joint, and updates its value j_val. This j_val value is updated according to a state machine, whose states are :  <a href="#ae24b2f1a2a766258e2797793cc23c085">More...</a><br /></td></tr>
<tr class="separator:ae24b2f1a2a766258e2797793cc23c085"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa0d67b26bbd09ee5de675813be2a9078"><td class="memItemLeft" align="right" valign="top"><a id="aa0d67b26bbd09ee5de675813be2a9078"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classQ__move.html#aa0d67b26bbd09ee5de675813be2a9078">publish_q</a> ()</td></tr>
<tr class="memdesc:aa0d67b26bbd09ee5de675813be2a9078"><td class="mdescLeft">&#160;</td><td class="mdescRight">Publish the q vector of the model, as a JointState message. <br /></td></tr>
<tr class="separator:aa0d67b26bbd09ee5de675813be2a9078"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Data Fields</h2></td></tr>
<tr class="memitem:a19b05a80cbc53164cdea27ef0f0c457c"><td class="memItemLeft" align="right" valign="top">ros::Publisher&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classQ__move.html#a19b05a80cbc53164cdea27ef0f0c457c">js_pub</a></td></tr>
<tr class="separator:a19b05a80cbc53164cdea27ef0f0c457c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a876c85d5e7fcd750e2738bbfc70d228e"><td class="memItemLeft" align="right" valign="top"><a id="a876c85d5e7fcd750e2738bbfc70d228e"></a>
pinocchio::Model&#160;</td><td class="memItemRight" valign="bottom"><b>model</b></td></tr>
<tr class="separator:a876c85d5e7fcd750e2738bbfc70d228e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a61de676b9721df3c09d5d7aa9c9c7e33"><td class="memItemLeft" align="right" valign="top"><a id="a61de676b9721df3c09d5d7aa9c9c7e33"></a>
std::vector&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>joint_state</b></td></tr>
<tr class="separator:a61de676b9721df3c09d5d7aa9c9c7e33"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d42d9d0302a2527c53e1f495eb24a1c"><td class="memItemLeft" align="right" valign="top"><a id="a0d42d9d0302a2527c53e1f495eb24a1c"></a>
std::vector&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>q</b></td></tr>
<tr class="separator:a0d42d9d0302a2527c53e1f495eb24a1c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a642ae4f9d6221f77e53d101664a78806"><td class="memItemLeft" align="right" valign="top"><a id="a642ae4f9d6221f77e53d101664a78806"></a>
double&#160;</td><td class="memItemRight" valign="bottom"><b>dt</b></td></tr>
<tr class="separator:a642ae4f9d6221f77e53d101664a78806"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa8335c477a8e5823996342e915839fbb"><td class="memItemLeft" align="right" valign="top"><a id="aa8335c477a8e5823996342e915839fbb"></a>
double&#160;</td><td class="memItemRight" valign="bottom"><b>speed</b></td></tr>
<tr class="separator:aa8335c477a8e5823996342e915839fbb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a91f399f3cf397215161b8c556412cace"><td class="memItemLeft" align="right" valign="top"><a id="a91f399f3cf397215161b8c556412cace"></a>
double&#160;</td><td class="memItemRight" valign="bottom"><b>j_val</b></td></tr>
<tr class="separator:a91f399f3cf397215161b8c556412cace"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Simple class testing the publication of Q vector to Rviz through JointState. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a635c60dab35a1cc6bafdfe318734f011"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a635c60dab35a1cc6bafdfe318734f011">&#9670;&nbsp;</a></span>Q_move()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Q_move::Q_move </td>
          <td>(</td>
          <td class="paramtype">const std::string&#160;</td>
          <td class="paramname"><em>urdf_filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>cons_speed</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>rate</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct a new q move::q move object. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">urdf_filename</td><td>: string, path to the .urdf file. </td></tr>
    <tr><td class="paramname">cons_speed</td><td>: double, desired speed of the articulations. </td></tr>
    <tr><td class="paramname">rate</td><td>: double, publication rate of the JointState messages. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ae24b2f1a2a766258e2797793cc23c085"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae24b2f1a2a766258e2797793cc23c085">&#9670;&nbsp;</a></span>move_all_articulations()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Q_move::move_all_articulations </td>
          <td>(</td>
          <td class="paramtype">double &amp;&#160;</td>
          <td class="paramname"><em>j_val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int &amp;&#160;</td>
          <td class="paramname"><em>i_joint</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Move a specific articulation i_joint, and updates its value j_val. This j_val value is updated according to a state machine, whose states are : </p>
<ul>
<li>0 : initialization of the articulation.</li>
<li>1 : change from j_val = 0 to j_val = maximum limit of the joint.</li>
<li>2 : change from j_val = maximum limit to j_val = minimum limit.</li>
<li>3 : change from j_val = minimum limit to j_val = 0.</li>
<li>4 : end of the movement of the joint.</li>
</ul>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">j_val</td><td>: double, current value of the joint. </td></tr>
    <tr><td class="paramname">i_joint</td><td>: int, index of the joint. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Field Documentation</h2>
<a id="a19b05a80cbc53164cdea27ef0f0c457c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a19b05a80cbc53164cdea27ef0f0c457c">&#9670;&nbsp;</a></span>js_pub</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">ros::Publisher Q_move::js_pub</td>
        </tr>
      </table>
</div><div class="memdoc">
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">js_pub</td><td>: Publisher of the JointState topic. </td></tr>
    <tr><td class="paramname">model</td><td>: Pinocchio model object, representing the .urdf model. </td></tr>
    <tr><td class="paramname">joint_state</td><td>: State machine vector, indicating the current state of each articulation. </td></tr>
    <tr><td class="paramname">q</td><td>: Q state vector.</td></tr>
    <tr><td class="paramname">dt</td><td>: double, time step between two publications. </td></tr>
    <tr><td class="paramname">speed</td><td>: double, speed of the articulations. </td></tr>
    <tr><td class="paramname">j_val</td><td>: current value of the moved articulation. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/q_pub.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
